module formulas.

%  This file provides some sample formulas for testing out our
%  theorem provers.

import fol.

kind	name		type.

type	formula		name -> form -> o.

type	a		i.
type	b		i.
type	c		i.
type	jar		i.
type    f               i -> i.

type    p               i -> form.
type    q               i -> form.
type    s               i -> form.
type	prime		i -> form.
type	green		i -> form.
type	blue		i -> form.
type	sterile		i -> form.
type	dead		i -> form.
type	animal		i -> form.
type	bug		i -> form.
type	heated		i -> form.

type	in		i -> i -> form.
type    r               i -> i -> form.
type	divides		i -> i -> form.
type	greater		i -> i -> form.
type	on_top		i -> i -> form.

type    y               form.
type    z               form.


type    quant_equiv     name.
type	reflexive	name.
type	primes		name.
type    modus_quant     name.
type	baffler		name.
type	blocks		name.
type	bugs		name.
type	cases1		name.
type	cases2		name.
type	cases3		name.
type    distrib_quant1  name.
type    distrib_quant2  name.
type    distrib_quant3  name.

formula distrib_quant1 (((forall X\ (q X)) or y) imp (forall X\ ((q X) or y))).
formula distrib_quant2 (((forall X\ (q X)) or z) imp (forall X\ ((q X) or z))).
formula distrib_quant3 ((forall X\ ((q X) and z)) imp ((forall X\ (q X)) and z)).

formula cases1 ((q a or q b) imp (exists X \ (q X))).

formula cases2
 ((((p a) or (q b)) and (forall X\ ((p X) imp (q X)))) imp (exists X\ (q X))).

formula cases3
 (((p a) or (s b)) and (forall X\ ((p X) imp (q X))) and
  (forall X\ ((q X) imp (s X))) imp (exists X\ (s X))).

formula bugs
 (((heated jar) and (forall X\ ((bug X) imp (animal X))) and
   (forall X\ (forall Y\ (((heated Y) and (in X Y) and (animal X))
                            imp (dead X)))) and
   (forall Y\ ((forall X\ (((in X Y) and (bug X)) imp (dead X)))
    imp (sterile Y))))
  imp (sterile jar)).

formula blocks
 (((forall Z\ ((blue Z) imp (neg (green Z)))) and
   (blue c) and (green a) and (on_top b c) and (on_top a b) and
   (forall W\ ((neg (green W)) or (green W))))
  imp (exists X\ (exists Y\ ((on_top X Y) and
                             (neg (green Y)) and (green X))))).

formula baffler (exists X\ (forall Y\ ((p X) imp (p Y)))).

formula modus_quant
(((p a) and (forall X\ ((p X) imp (q X)))) imp (exists X\ (q X))).

formula primes
 (((forall N\ ((neg (prime N)) or (prime N))) and
   (forall X\ (greater (f X) X)) and
   (forall X\ (forall Y\ ((divides X (f Y)) imp (greater X Y)))) and
   (forall X\
     ((neg (prime X)) imp (exists Y\ ((prime Y) and (divides Y X))))))
  imp (forall N\ (exists X\ ((greater X N) and (prime X))))).

formula reflexive
 (((forall X\ (forall Y\ (forall Z\ (((r X Y) and (r Y Z)) imp (r X Z)))))
   and (forall X\ (forall Y\ ((r X Y) imp (r Y X))))) imp
  (forall X\ ((exists Y\ (r X Y)) imp (r X X)))).

formula quant_equiv
 ((exists X\ (forall Y\ (((p X) imp (p Y)) and ((p Y) imp (p X)))))
  imp (((exists X\ (p X)) imp (forall Y\ (p Y)))
       and ((forall Y\ (p Y)) imp (exists X\ (p X))))).
