% This module contains the >-1 program for performing the first step
% of an automatic theorem prover for
% a sequent system for first-order classical logic.

module lc_auto.

import  lc_iter lists.

type    '>-1'   lprf -> seq -> o.

(initial A) >-1 (Gamma --> Delta) :- memb A Gamma, memb A Delta.

(and_l Q) >-1 (Gamma --> Delta) :-
  memb_and_rest (A and B) Gamma Gamma1, Q >-1 ((A::B::Gamma1) --> Delta).

(imp_r Q) >-1 (Gamma --> Delta) :-
  memb_and_rest (A imp B) Delta Delta1, Q >-1 ((A::Gamma) --> (B::Delta1)).

(exists_l Q) >-1 (Gamma --> Delta) :-
  memb_and_rest (exists A) Gamma Gamma1,
  (pi T \ ((Q T) >-1 (((A T)::Gamma1) --> Delta))).

(forall_r Q) >-1 (Gamma --> Delta) :-
  memb_and_rest (forall A) Delta Delta1,
  (pi T \ ((Q T) >-1 (Gamma --> ((A T)::Delta1)))).

(or_l Q1 Q2) >-1 (Gamma --> Delta) :-
  memb_and_rest (A or B) Gamma Gamma1,
  Q1 >-1 ((A::Gamma1) --> Delta), Q2 >-1 ((B::Gamma1) --> Delta).

(and_r Q1 Q2) >-1 (Gamma --> Delta) :-
  memb_and_rest (A and B) Delta Delta1,
  Q1 >-1 (Gamma --> (A::Delta1)), Q2 >-1 (Gamma --> (B::Delta1)).

(imp_l Q1 Q2) >-1 (Gamma --> Delta) :-
  memb_and_rest (A imp B) Gamma Gamma1,
  Q1 >-1 (Gamma1 --> (A::Delta)), Q2 >-1 ((B::Gamma1) --> Delta).

(neg_r Q) >-1 (Gamma --> Delta) :-
  memb_and_rest (neg A) Delta Delta1, Q >-1 ((A::Gamma) --> Delta1).

(or_r Q) >-1 (Gamma --> Delta) :-
  memb_and_rest (A or B) Delta Delta1, Q >-1 (Gamma --> (A::B::Delta1)).

(neg_l Q) >-1 (Gamma --> Delta) :-
  memb_and_rest (neg A) Gamma Gamma1, Q >-1 (Gamma1 --> (A::Delta)).

Q >-1 Seq :- nprove 1 Q Seq.
