module lfconv.

import lfsig.

type    redex_ty        ty -> ty -> o.
type    redex_tm        tm -> tm -> o.
type    red1_ki         ki -> ki -> o.
type    red1_ty         ty -> ty -> o.
type    red1_tm         tm -> tm -> o.
type    conv_ki         ki -> ki -> o.
type    conv_ty         ty -> ty -> o.
type    conv_tm         tm -> tm -> o.

redex_ty (app_ty (abs_ty B A) N) (B N).
redex_tm (app_tm (abs_tm M A) N) (M N).

red1_ki (prod_ki K1 A) (prod_ki K2 A) :- pi X\ (red1_ki (K1 X) (K2 X)).
red1_ki (prod_ki K A1) (prod_ki K A2) :- red1_ty A1 A2.

red1_ty A1 A2 :- redex_ty A1 A2.
red1_ty (prod_ty B1 A) (prod_ty B2 A) :- pi X\ (red1_ty (B1 X) (B2 X)).
red1_ty (prod_ty B A1) (prod_ty B A2) :- red1_ty A1 A2.
red1_ty (abs_ty B1 A) (abs_ty B2 A) :- pi X\ (red1_ty (B1 X) (B2 X)).
red1_ty (abs_ty B A1) (abs_ty B A2) :- red1_ty A1 A2.
red1_ty (app_ty A1 N) (app_ty A2 N) :- red1_ty A1 A2.
red1_ty (app_ty A N1) (app_ty A N2) :- red1_tm N1 N2.

red1_tm M1 M2 :- redex_tm M1 M2.
red1_tm (abs_tm M1 A) (abs_tm M2 A) :- pi X\ (red1_tm (M1 X) (M2 X)).
red1_tm (abs_tm M A1) (abs_tm M A2) :- red1_ty A1 A2.
red1_tm (app_tm M1 N) (app_tm M2 N) :- red1_tm M1 M2.
red1_tm (app_tm M N1) (app_tm M N2) :- red1_tm N1 N2.

conv_ki K K.
conv_ki K L :- conv_ki L K.
conv_ki K L :- conv_ki K Q, conv_ki Q L.
conv_ki K L :- red1_ki K L.

conv_ty A A.
conv_ty A B :- conv_ty B A.
conv_ty A B :- conv_ty A C, conv_ty C B.
conv_ty A B :- red1_ty A B.

conv_tm M M.
conv_tm M N :- conv_tm N M.
conv_tm M N :- conv_tm M P, conv_tm P N.
conv_tm M N :- red1_tm M N.
