
module metaebg. 


type  box		        o -> o.		

type  gsolve			o -> o -> o.

type  hyp			o -> o.
type  ghyp			o -> o -> o.

type  wsolve			o -> o -> o -> o. 
type  ssolve			o -> o -> o -> o.

type  wmatch			o -> o -> o -> o -> o -> o.
type  smatch			o -> o -> o -> o -> o -> o. 
type  bmatch			o -> o -> o -> o -> o -> o. 

type  meta_wsolve		o -> o -> o.
type  meta_ssolve		o -> o -> o.

type  breduce			o -> o -> o.
type  reduce			o -> o -> o.
type  reduce1			o -> o -> o.

type  dosolve			o -> o -> o -> o. 
type  dosolve1			o -> o -> o -> o. 
type  dosolve2			o -> o -> o -> o. 
type  dosolve3			o -> o -> o -> o. 




  % The following suppress error messages...
hyp true.
ghyp true true. 
   

index wsolve 1.
index ssolve 1.
index wmatch 1.
index smatch 1.
index meta_wsolve 1.
index meta_ssolve 1.
index breduce 1.
index reduce 1.
index reduce1 1.


ssolve (G1 ; G2)  (GG1 ; GG2)  DD
       :- !, error (writesans "Illegal disjunction in boxed goal"). 
ssolve (D => G)   (DD1 => GG)  DD2
       :- !, error (writesans "Illegal implication in boxed goal").
ssolve (sigma G)  (sigma GG)   (DD T)     
       :- !, error (writesans "Illegal existential in boxed goal").



wmatch (D1 ; D2)  Ga  (DD1 ; DD2)  GGa  MG 
    :- !, error (writesans "Illegal disjunction in program").
wmatch (sigma D)  Ga  (DD X)       GGa  MG
    :- !, error (writesans "Illegal existential in program").

smatch (D1 ; D2)  Ga  (DD1 ; DD2)  GGa  MG 
    :- !, error (writesans "Illegal disjunction in program").
smatch (sigma D)  Ga  (DD X)       GGa  MG
    :- !, error (writesans "Illegal existential in program").





wsolve true       true         true        :- !.
wsolve (G1 , G2)  (GG1 , GG2)  (DD1 , DD2) :- !, wsolve G1 GG1 DD1,
                                                 wsolve G2 GG2 DD2.
wsolve (G1 ; G2)  (GG1 ; GG2)  DD          :- !, (wsolve G1 GG1 DD;
                                                  wsolve G2 GG2 DD).
wsolve (D => G)   (DD => GG)   DD1         :- !, ghyp D DD => wsolve G GG DD1.
wsolve (pi G)     (pi GG)      (DD X)      :- !, pi X\ 
                                                  (wsolve (G X) (GG X) (DD X)).
wsolve (sigma G)  (sigma GG)   (DD T)      :- !, wsolve (G T) (GG T) (DD T).
wsolve (box G)    (box GG)     DD          :- !, ssolve G GG DD.
wsolve (once G)   (once GG)    DD	   :- !, once (wsolve G GG DD).
wsolve Ga         GGa          DD1         :-    ghyp D DD,
                                                 wmatch D Ga DD GGa MG,
                                                 meta_wsolve MG DD1.
wsolve Ga         GGa          (DD , DD1)  :- !, hyp D,
                                                 wmatch D Ga DD GGa MG,
                                                 meta_wsolve MG DD1.



ssolve true       true         true        :- !.
ssolve (G1 , G2)  (GG1 , GG2)  (DD1 , DD2) :- !, ssolve G1 GG1 DD1,
                                                 ssolve G2 GG2 DD2.
ssolve (pi G)     (pi GG)      (DD X)      :- !, pi X\
                                                  (ssolve (G X) (GG X) (DD X)).
ssolve (box G)    (box GG)     DD          :- !, ssolve G GG DD.
ssolve (once G)   (once GG)    DD	   :- !, once (ssolve G GG DD).
ssolve Ga         GGa          DD1         :-    ghyp D DD,
                                                 smatch D Ga DD GGa MG,
                                                 meta_wsolve MG DD1.
ssolve Ga         GGa          (DD , DD1)  :- !, hyp D,
                                                 smatch D Ga DD GGa MG,
                                                 meta_wsolve MG DD1.




wmatch (D1 , D2)  Ga  DD           GGa  MG :- !, (wmatch D1 Ga DD GGa MG;
				                  wmatch D2 Ga DD GGa MG).
wmatch (G => D)   Ga  (GG => DD)   GGa  (gsolve G GG, MG)
			                   :- !, wmatch D Ga DD GGa MG.
wmatch (pi D)     Ga  DD           GGa  MG :- !, wmatch (D X) Ga DD GGa MG.
wmatch (box D)    Ga  (box D)      GGa  MG :- !, bmatch D Ga D GGa MG.
wmatch Ga         Ga  GGa          GGa  true.




smatch (D1 , D2)  Ga  DD           GGa  MG :- !, (smatch D1 Ga DD GGa MG;
				                  smatch D2 Ga DD GGa MG).
smatch (G => D)   Ga  (GG => DD)   GGa  (gsolve G GG, MG)
			                   :- !, smatch D Ga DD GGa MG.
smatch (pi D)     Ga  DD           GGa  MG :- !, smatch (D X) Ga DD GGa MG.
smatch (box D)    Ga  (box D)      GGa  (box MG)
					   :- !, bmatch D Ga D GGa MG.





bmatch (D1 , D2)  Ga  (DD1 , DD2)  GGa  MG :- !, (bmatch D1 Ga DD1 GGa MG;
				                  bmatch D2 Ga DD2 GGa MG).
bmatch (G => D)   Ga  (GG => DD)   GGa  (gsolve G GG, MG)
			                   :- !, bmatch D Ga DD GGa MG.
bmatch (pi D)     Ga  (pi DD)      GGa  MG :- !, bmatch (D  X:A) Ga 
							(DD Y:A) GGa MG.
bmatch (box D)    Ga  (box D)      GGa  MG :- !, bmatch D Ga D GGa MG.
bmatch Ga         Ga  GGa          GGa  true.










meta_wsolve true	   true        :- !.
meta_wsolve (MG1 , MG2)    (DD1 , DD2) :- !, meta_wsolve MG1 DD1, 
					     meta_wsolve MG2 DD2.
meta_wsolve (box MG)       DD          :- !, meta_ssolve MG DD.
meta_wsolve (gsolve G GG)  DD          :- !, wsolve G GG DD.


meta_ssolve true	   true        :- !.
meta_ssolve (MG1 , MG2)    (DD1 , DD2) :- !, meta_ssolve MG1 DD1, 
					     meta_ssolve MG2 DD2.
meta_ssolve (box MG)       DD          :- !, meta_ssolve MG DD.
meta_ssolve (gsolve G GG)  DD          :- !, ssolve G GG DD.








dosolve  G GG DD :- !, wsolve G GG DD1, breduce DD1 DD2, reduce DD2 DD.

dosolve1 G GG DD :- !, wsolve G GG DD1, reduce DD1 DD.

dosolve2 G GG DD :- !, wsolve G GG DD1, breduce DD1 DD.

dosolve3 G GG DD :- !, wsolve G GG DD.




%% Replaces "(box H)" with "true" in hypotheses.

%% Box-REDUCE      H:in	H:out

breduce  true       true          :- !.
    % Above should be first to avoid infinite recursion on variables.  This
    % allows uninstaniated variables to be 'reduced' out of the picture.  Good
    % for all but haigher-order generalizations.  
breduce  (H1 , H2)  (H1i , H2i)   :- !, breduce H1 H1i, breduce H2 H2i.
breduce  (H1 ; H2)  (H1i ; H2i)   :- !, breduce H1 H1i, breduce H2 H2i.
breduce  (H1 => H2) (H1i => H2i)  :- !, breduce H1 H1i, breduce H2 H2i.
breduce  (pi H)     (pi Hi)       :- !, pi X\ (breduce (H X) (Hi X)).
breduce  (sigma H)  (sigma Hi)    :- !, pi X\ (breduce (H X) (Hi X)).
breduce  (box H)    true          :- !.
breduce  Ha         Ha		  :- !.




%% Simplifies goal structure.

%% REDUCE      H:in	H:out

reduce   true         true	   :- !.  
    % Above should be first to avoid infinite recursion on variables. This
    % allows uninstaniated variables to be 'reduced' out of the picture.  Good
    % for all but higher-order generalizations.
reduce   (H1 , H2)   H	           :- !, reduce H1 H1i, reduce H2 H2i, 
				         reduce1 (H1i , H2i) H.
reduce   (H1 ; H2)   H	           :- !, reduce H1 H1i, reduce H2 H2i, 
				         reduce1 (H1i ; H2i) H.
reduce   (H1 => H2)  H	           :- !, reduce H1 H1i, reduce H2 H2i, 
				         reduce1 (H1i => H2i) H.
reduce   (pi H1)     H	           :- !, pi X\ (reduce (H1 X) (H1i X)), 
				         reduce1 (pi H1i) H.
reduce   (sigma H1)  H	           :- !, pi X\ (reduce (H1 X) (H1i X)), 
				         reduce1 (sigma H1i) H.
reduce   (box H1)    H	           :- !, reduce H1 H1i, 
				         reduce1 (box H1i) H.
reduce   Ha	     Ha	           :- !.


reduce1   true	           true	   :- !.
reduce1   (true , H2)      H2      :- !.
reduce1   (H1 , true)      H1	   :- !.
reduce1   (true ; H2)      true    :- !.
reduce1   (H1 ; true)      true	   :- !.
reduce1   (true => H2)     H2      :- !.
reduce1   (H1 => true)     true	   :- !.
reduce1   (pi X\ true)     true	   :- !.
reduce1   (sigma X\ true)  true	   :- !.
reduce1	  (box true)	   true	   :- !.
reduce1	  H		   H	   :- !.



