% theorem prover for NJ, version for eLP
% builds normal proofs (without E-segments), backward direction for epart

module nj_ebg.

import  form nproofex.
import  metaebg.

type    nproof          bool -> proof_object -> o.
index   nproof          2.
type    epart           bool -> proof_object -> o.
index   epart           2.
type    proofcheck      name -> o.



hyp (box (pi A\ (pi P\ (pi B\ 
   (epart A (and_e1 P) :-
    epart (A and B) P))))).

hyp (box (pi A\ (pi P\ (pi B\ 
   (epart B (and_e2 P) :-
    epart (A and B) P))))).

hyp (box (pi A\ (pi P\ (pi B\ (pi PA\
   (epart B (imp_e PA P) :-
    epart (A imp B) P,
    nproof A PA)))))).

hyp (box (pi A\ (pi P\ (pi T\ 
   (epart (A T) (forall_e T P) :-
    epart (forall A) P))))).



hyp (box (pi A\ (pi P\
   (nproof A P :- epart A P)))).

hyp (box (pi A\ (pi P1\ (pi B\ (pi P2\
   (nproof (A and B) (and_i P1 P2) :-
    nproof A P1, nproof B P2)))))).

hyp (box (pi A\ (pi P\ (pi B\ 
   (nproof (A or B) (or_i1 P) :-
    nproof A P))))).

hyp (box (pi A\ (pi P\ (pi B\ 
   (nproof (A or B) (or_i2 P) :-
    nproof B P))))).

hyp (box (pi A\ (pi P\ (pi B\ 
   (nproof (A imp B) (imp_i P) :-
    pi PA\ ((epart A PA) => (nproof B (P PA)))))))).

hyp (box (pi A\ (pi P\ 
   (nproof (forall A) (forall_i P) :-
    pi T\ (nproof (A T) (P T)))))).

hyp (box (pi A\ (pi P\ (pi T\
   (nproof (exists A) (exists_i T P) :-
    nproof (A T) P))))).

hyp (box (pi A\ (pi P1\ (pi B\ (pi P2\ (pi C\ (pi P\
   (nproof C (or_e P P1 P2) :-
     epart (A or B) P,
     pi PA\ ((epart A PA) => (nproof C (P1 PA))),
     pi PB\ ((epart B PB) => (nproof C (P2 PB))))))))))).

hyp (box (pi A\ (pi PB\ (pi B\ (pi P\
   (nproof B (exists_e P PB) :-
    epart (exists A) P,
    pi T\ (pi PA\ ((epart (A T) PA) => (nproof B (PB T PA)))))))))).

hyp (box (pi A\ (pi P\
   (nproof A (false_i P) :-
    nproof false P)))).


proofck_ebg Name G GG DD :-
  formula Name Formula,
  proofex Name Proof,
  G = nproof Formula Proof,
  dosolve G GG DD.


%%   Slow, slow, slow...
%%   possible formulas imp_trans, reflexive, primes.

%%   Other results in nj_ebg.rec

%   ?- proofck_ebg imp_trans G GG DD.
%   Solving . . .
%   G == nproof ((pp imp qq) imp (rr imp pp) imp rr imp qq)
%     (imp_i P1 \ (imp_i P2 \ (imp_i P3 \ (imp_e (imp_e P3 P2) P1))))
%   GG == nproof ((Y imp Y1) imp (Y2 imp Y) imp Y2 imp Y1)
%     (imp_i X \ (imp_i X1 \ (imp_i X2 \ (imp_e (imp_e X2 X1) X))))
%   DD == true.

