% Some example natural deduction proofs.

module nproofex.

import ndproofs form.

type    proofex         name -> proof_object -> o.
type    form_and_proof  name -> bool -> proof_object -> o.

proofex imp_trans
  (imp_i P1\ (imp_i P2\ (imp_i P3\ (imp_e (imp_e P3 P2) P1)))).

proofex reflexive
 (imp_i P1\ (forall_i X1\ (imp_i P2\ (exists_e P2
   X2\ P3\ (imp_e (and_i P3 (imp_e P3 (forall_e X2 (forall_e X1 (and_e2 P1)))))
                  (forall_e X1 (forall_e X2 (forall_e X1 (and_e1 P1))))))))).

proofex primes
  (imp_i P1\
   (forall_i X1\
    (or_e (forall_e (f X1) (and_e1 P1))
          P2\ (exists_e (imp_e P2 (forall_e (f X1) (and_e2
                                                    (and_e2 (and_e2 P1)))))
                        X2\ P3\ (exists_i X2
                                  (and_i 
                                    (imp_e (and_e2 P3)
                                           (forall_e X1 (forall_e X2
                                             (and_e1 (and_e2 (and_e2 P1))))))
                                    (and_e1 P3))))
          P4\ (exists_i (f X1) (and_i (forall_e X1 (and_e1 (and_e2 P1)))
                                      P4))))).

form_and_proof Name Formula Proof :- formula Name Formula,
                                     proofex Name Proof.
