module ebg_tacticals.

import metaebg_ext.


% Special tactics.

type   idtac			o -> o -> o.
type   quit			o -> o -> o.


% Tacticals.

type   maptac			(o -> o -> o) -> o -> o -> o.
type   then			(o -> o -> o) -> (o -> o -> o) -> o -> o -> o.
type   orelse  			(o -> o -> o) -> (o -> o -> o) -> o -> o -> o.
type   repeat			(o -> o -> o) -> o -> o -> o.
type   try			(o -> o -> o) -> o -> o -> o.
type   complete			(o -> o -> o) -> o -> o -> o.

type   stop			(o -> o -> o) -> o -> o -> o.

type   myreduce			o -> o -> o. 
type   myequal			A -> A -> o. 
type   interact_solve		o -> o -> o. 







hyp (box (pi OGa\ (pi OGb\ (pi Tac\ (pi OGa1\ (pi OGb1\ (pi OG\
   (maptac Tac (OGa , OGb) OG :- 
     maptac Tac OGa OGa1, 
     maptac Tac OGb OGb1,
     myreduce (OGa1 , OGb1) OG)))))))).

hyp (box (pi OGa\ (pi OGb\ (pi Tac\ (pi OG\ (pi OGa1\ (pi OGb1\
   (maptac Tac (OGa ; OGb) OG :- 
     maptac Tac OGa OGa1, 
     maptac Tac OGb OGb1,
     myreduce (OGa1 ; OGb1) OG)))))))).

hyp (box (pi IG\ (pi OG\ (pi Tac\ (pi OG1\
   (maptac Tac IG OG :- 
      Tac IG OG1, 
      myreduce OG1 OG)))))).

hyp (box (pi Tac\
   (maptac Tac true true))).



hyp (box (pi Tac1\ (pi Tac2\ (pi OG\ (pi OG1\ (pi OG2\ (pi OG3\ (pi OG4\
   (then Tac1 Tac2 OG OG4 :- 
       Tac1 OG OG1,
       myreduce OG1 OG2, 
       maptac Tac2 OG2 OG3,
       myreduce OG3 OG4))))))))).


hyp (box (pi Tac1\ (pi Tac2\ (pi OG\ (pi OG1\ (pi OG2\
   (orelse Tac1 Tac2 OG OG2 :- 
       (Tac1 OG OG1 ; Tac2 OG OG1), 
       myreduce OG1 OG2))))))).



hyp (box (pi Tac\ (pi OG\ (pi OG1\
   (repeat Tac OG OG1 :- 
       (orelse (then Tac (repeat Tac)) idtac OG OG1)))))). 


hyp (box (pi Tac\ (pi OG\ (pi OG1\
   (try Tac OG OG1 :- 
       (orelse Tac idtac OG OG1)))))).


hyp (box (pi Tac\ (pi OG\ (pi OG1\
   (complete Tac OG true :- 
       (Tac OG OG1, myreduce OG1 true)))))).


hyp (box (pi Tac\ (pi OG\ (pi OG1\ (pi OG2\ 
   (stop Tac OG OG1 :- Tac OG OG1, quit OG1 OG2)))))).





hyp (box (pi A\ (pi B\
   (myreduce (true , A) B :- myreduce A B)))).

hyp (box (pi A\ (pi B\
   (myreduce (A , true) B :- myreduce A B)))).

hyp (box (pi A\ 
   (myreduce (true ; A) true))). 

hyp (box (pi A\
   (myreduce (A ; true) true))). 

hyp (box (pi A\
   (myreduce A A))).




hyp (box (pi OG1\ 
   (myequal OG1 OG1))).




hyp (box (pi OG\ (pi OGi\ (pi OGii\ (pi Tac1\ (
  (interact_solve OG OGii :- 
     (nl, writesans "Meta-goal to be reduced:  ",
      write OG, nl,
      nl, writesans "Enter tactic/tactical ",
      read (Tac \ 
        (Tac OG OGi, 
          (((myequal Tac quit ; myequal Tac (stop Tac1) ; myequal OGi true) ,
            idtac OGi OGii) ; 
           interact_solve OGi OGii))))))))))).



   % We want the following to be checked first (for speed).

hyp (box (pi OG\ 
   (idtac OG OG))).

hyp (box (pi OG\ (pi OG1\ 
   (quit OG OG1 :- idtac OG OG1)))).


