
module metaebg_ext.

% Extended to handle some IO.

type  box		        o -> o.		

type  gsolve			o -> o -> o.

type  hyp			o -> o.
type  ghyp			o -> o -> o.


type  wsolve			o -> o -> o -> o. 
type  ssolve			o -> o -> o -> o.

type  wmatch			o -> o -> o -> o -> o -> o.
type  smatch			o -> o -> o -> o -> o -> o. 

type  meta_wsolve		o -> o -> o.
type  meta_ssolve		o -> o -> o.

type  breduce			o -> o -> o.
type  reduce			o -> o -> o.

type  dosolve			o -> o -> o -> o. 
type  dosolve1			o -> o -> o -> o. 



  % The following suppress error messages...
hyp true.
ghyp true true. 
   

index wsolve 1.
index ssolve 1.
index wmatch 1.
index smatch 1.
index meta_wsolve 1.
index meta_ssolve 1.
index breduce 1.
index reduce 1.


ssolve (G1 ; G2)  (GG1 ; GG2)  DD
       :- !, error (writesans "Illegal disjunction in boxed goal"). 
ssolve (D => G)   (DD1 => GG)  DD2
       :- !, error (writesans "Illegal implication in boxed goal").
ssolve (sigma G)  (sigma GG)   (DD T)     
       :- !, error (writesans "Illegal existential in boxed goal").



wmatch (D1 ; D2)  Ga  (DD1 ; DD2)  GGa  MG 
    :- !, error (writesans "Illegal disjunction in program").
wmatch (sigma D)  Ga  (DD X)       GGa  MG
    :- !, error (writesans "Illegal existential in program").

smatch (D1 ; D2)  Ga  (DD1 ; DD2)  GGa  MG 
    :- !, error (writesans "Illegal disjunction in program").
smatch (sigma D)  Ga  (DD X)       GGa  MG
    :- !, error (writesans "Illegal existential in program").





wsolve true       true         true        :- !.
wsolve (G1 , G2)  (GG1 , GG2)  (DD1 , DD2) :- !, wsolve G1 GG1 DD1,
                                                 wsolve G2 GG2 DD2.
wsolve (G1 ; G2)  (GG1 ; GG2)  DD          :- !, (wsolve G1 GG1 DD;
                                                  wsolve G2 GG2 DD).
wsolve (D => G)   (DD => GG)   DD1         :- !, ghyp D DD => wsolve G GG DD1.
wsolve (pi G)     (pi GG)      (DD X)      :- !, pi X\ 
                                                  (wsolve (G X) (GG X) (DD X)).
wsolve (sigma G)  (sigma GG)   (DD T)      :- !, wsolve (G T) (GG T) (DD T).
wsolve (box G)    (box GG)     DD          :- !, ssolve G GG DD.


wsolve nl	      nl 	       true	   :- !, nl.
wsolve (writesans S)  (writesans SS)   true	   :- !, writesans S.
wsolve (write S)      (write SS)       true	   :- !, write S.
wsolve (read G)       (read GG)	       DD	   :- !, read T\ 
						 (wsolve (G T) (GG T) DD).
%%       T not passed to DD ???
wsolve !	      !    	       true	   :- !.
%wsolve (equal S T)    (equal SS SS)    true	   :- !, S = T.



wsolve Ga         GGa          DD2         :-    ghyp D DD1,
                                                 wmatch D Ga DD1 GGa MG,
                                                 meta_wsolve MG DD2.

						 
wsolve Ga         GGa          (DD1 , DD2) :- !, hyp D,
                                                 wmatch D Ga DD1 GGa MG,
                                                 meta_wsolve MG DD2.



ssolve true       true         true        :- !.
ssolve (G1 , G2)  (GG1 , GG2)  (DD1 , DD2) :- !, ssolve G1 GG1 DD1,
                                                 ssolve G2 GG2 DD2.
ssolve (pi G)     (pi GG)      (DD X)      :- !, pi X\
                                                  (ssolve (G X) (GG X) (DD X)).
ssolve (box G)    (box GG)     DD          :- !, ssolve G GG DD.




ssolve nl	      nl	       true	   :- !, nl.
ssolve (writesans S)  (writesans SS)   true	   :- !, writesans S.
ssolve (write S)      (write SS)       true	   :- !, write S.
ssolve (read G)       (read GG)	       DD	   :- !, read T\ 
						 (ssolve (G T) (GG T) DD).
%%       T not passed to DD ???
ssolve !	      !   	       true	   :- !.
%ssolve (equal S T)    (equal SS SS)    true	   :- !, S = T.




ssolve Ga         GGa          DD2         :-    ghyp D DD1,
                                                 smatch D Ga DD1 GGa MG,
                                                 meta_wsolve MG DD2.
ssolve Ga         GGa          (DD1 , DD2) :- !, hyp D,
                                                 smatch D Ga DD1 GGa MG,
                                                 meta_wsolve MG DD2.





wmatch (D1 , D2)  Ga  (DD1 , DD2)  GGa  MG  :- !, (wmatch D1 Ga DD1 GGa MG;
				                   wmatch D2 Ga DD2 GGa MG).
wmatch (G => D)   Ga  (GG => DD)   GGa  (gsolve G GG, MG)
			                    :- !, wmatch D Ga DD GGa MG.
wmatch (pi D)     Ga  (pi DD)      GGa  MG  :- !, wmatch (D X) Ga (DD Y) GGa MG.
wmatch (box D)    Ga  (box D)      GGa  MG  :- !, wmatch D Ga D GGa MG.
wmatch Ga         Ga  GGa          GGa  true.




smatch (D1 , D2)  Ga  (DD1 , DD2)  GGa  MG  :- !, (smatch D1 Ga DD1 GGa MG;
				                   smatch D2 Ga DD2 GGa MG).
smatch (G => D)   Ga  (GG => DD)   GGa  (gsolve G GG, MG)
			                    :- !, smatch D Ga DD GGa MG.
smatch (pi D)     Ga  (pi DD)      GGa  MG  :- !, smatch (D X) Ga (DD Y) GGa MG.
smatch (box D)    Ga  (box D)      GGa  (box MG)
					    :- !, wmatch D Ga D GGa MG.






meta_wsolve true	   true        :- !.
meta_wsolve (MG1 , MG2)    (DD1 , DD2) :- !, meta_wsolve MG1 DD1, 
					     meta_wsolve MG2 DD2.
meta_wsolve (box MG)       DD          :- !, meta_ssolve MG DD.
meta_wsolve (gsolve G GG)  DD          :- !, wsolve G GG DD.


meta_ssolve true	   true        :- !.
meta_ssolve (MG1 , MG2)    (DD1 , DD2) :- !, meta_ssolve MG1 DD1, 
					     meta_ssolve MG2 DD2.
meta_ssolve (box MG)       DD          :- !, meta_ssolve MG DD.
meta_ssolve (gsolve G GG)  DD          :- !, ssolve G GG DD.








dosolve  G GG DD :- !, wsolve G GG DD1, breduce DD1 DD2, reduce DD2 DD.

dosolve1 G GG DD :- !, wsolve G GG DD1, reduce DD1 DD.





%% Replaces "(box H)" with "true" in hypotheses.

%% Box-REDUCE      H:in	H:out

breduce  true       true          :- !.
    % Above should be first to avoid infinite recursion on variables.  This
    % allows uninstaniated variables to be 'reduced' out of the picture.  Good
    % for all but haigher-order generalizations.  
breduce  (H1 , H2)  (H1i , H2i)   :- !, breduce H1 H1i, breduce H2 H2i.
breduce  (H1 ; H2)  (H1i ; H2i)   :- !, breduce H1 H1i, breduce H2 H2i.
breduce  (H1 => H2) (H1i => H2i)  :- !, breduce H1 H1i, breduce H2 H2i.
breduce  (pi H)     (pi Hi)       :- !, pi X\ (breduce (H X) (Hi X)).
breduce  (sigma H)  (sigma Hi)    :- !, pi X\ (breduce (H X) (Hi X)).
breduce  (box H)    true          :- !.
breduce  Ha         Ha		  :- !.




%% Simplifies goal structure.

%% REDUCE      H:in	H:out

reduce   true         true	   :- !.  
    % Above should be first to avoid infinite recursion on variables. This
    % allows uninstaniated variables to be 'reduced' out of the picture.  Good
    % for all but haigher-order generalizations.  
reduce   (H1 , H2)  H1i            :- reduce H2 true, !, reduce H1 H1i.
reduce   (H1 , H2)  H2i            :- reduce H1 true, !, reduce H2 H2i.
reduce   (H1 , H2)  (H1i , H2i)    :- !, reduce H1 H1i, reduce H2 H2i.
reduce   (H1 ; H2)  true           :- reduce H2 true, !.
reduce   (H1 ; H2)  true           :- reduce H1 true, !.
reduce   (H1 ; H2)  (H1i ; H2i)    :- !, reduce H1 H1i, reduce H2 H2i.
reduce   (H1 => H2) H2i            :- reduce H1 true, !, reduce H2 H2i.   
reduce   (H1 => H2) true	   :- reduce H2 true, !.           
reduce   (H1 => H2) (H1i => H2i)   :- !, reduce H1 H1i, reduce H2 H2i.
reduce   (pi H)     true           :- pi X\ (reduce (H X) true), !.
reduce   (pi H)     (pi Hi)        :- !, pi X\ (reduce (H X) (Hi X)).
reduce   (sigma H)  true           :- pi X\ (reduce (H X) true), !.
reduce   (sigma H)  (sigma Hi)     :- !, pi X\ (reduce (H X) (Hi X)).
reduce   (box H)    true	   :- reduce H true, !.
reduce   (box H)    (box Hi)	   :- !, reduce H Hi.
reduce   Ha         Ha	           :- !.

