
module tac_integrate.

import metaebg_ext ebg_tacticals.


type   expn 			int -> int -> int.
type   ~			int -> int.
type   log			int -> int.
type   intgr             	(int -> int) -> (int -> int) -> o.

type   dx			o -> o -> o.
type   cf			o -> o -> o.
type   p1			o -> o -> o.
type   pm1			o -> o -> o.
type   pw			o -> o -> o.
type   cf_l			o -> o -> o.
type   cf_r			o -> o -> o.
type   pl			o -> o -> o.



hyp (box 
       (dx         (intgr     (X\ 1)             (X\ X))
		   true)).

hyp (box (pi A\ 
       (cf        (intgr      (X\ A)             (X\ (A * X)))
		   true))).
		  
hyp (box 
       (p1         (intgr     (X\ X)             (X\ ((expn X 2) div 2)))
		   true)).

hyp (box
       (pm1        (intgr  (X\ (expn X (~ 1)))   (X\ (log X)))
		   true)).

hyp (box (pi A\
       (pw         (intgr   (X\ (expn X A))   
			    (X\ ((expn X (A + 1)) div (A + 1))))
	           true))).

hyp (box (pi A\ (pi B\ (pi Bi\ 
       (cf_l       (intgr  (X\ (A * (B X)))   (X\ (A * (Bi X))))
                   (intgr     (X\ (B X))         (X\ (Bi X)))))))).

hyp (box (pi A\ (pi B\ (pi Bi\
       (cf_r       (intgr  (X\ ((B X) * A))   (X\ ((Bi X) * A)))
		   (intgr     (X\ (B X))         (X\ (Bi X)))))))).

hyp (box (pi A\ (pi B\ (pi Ai\ (pi Bi\
       (pl         (intgr   (X\ ((A X) + (B X)))   (X\ ((Ai X) + (Bi X))))
		   ((intgr     (X\ (A X))             (X\ (Ai X))) ,
		    (intgr   (X\ (B X))             (X\ (Bi X)))))))))).










%%    Standard queries:

%   dosolve (interact_solve (intgr (X\ (2 * (3 * X))) F)  true)  GG DD.

%%  (then (repeat cf_l) p1).


%   dosolve (interact_solve (intgr (X\ (3 * (expn X 2))) F)  OutGoal)  GG DD.

%%   then cf_l pw.



% dosolve (interact_solve (intgr (X\ (2 + (3 * (expn X 2)))) F) OutGoal) GG DD.

%%   then pl (maptac (orelse cf (then cf_l pw))).






%% More examples.

ex0 O1 O2 G GG DD :- 
  O1 = (intgr  (X \ 1)  (X\ X)),
  G = (interact_solve O1 O2), 
  dosolve G GG DD.


% Enter tactical  ?- dx.
%
% O1 == intgr X \ 1 X \ X
% O2 == true
% G == interact_solve (intgr X \ 1 X \ X) true
% GG == interact_solve (intgr X \ 1 X \ X) true
% DD == true


ex1 O1 O2 G GG DD :- 
  O1 = (intgr  (X \ (expn X 2))  F),
  G = (interact_solve O1 O2), 
  dosolve G GG DD.



expaper O1 O2 G GG DD :- 
 O1 = (intgr (X \ (2 * (3 * X)))  F),
  G = (interact_solve O1 O2), 
  dosolve G GG DD.

%%	   complete (then (repeat cf_l) p1).



expaper1 O1 O2 G GG DD :-
  O1 = (intgr  (X \ (3 * (expn X 2))) F),
  G = (interact_solve O1 O2), 
  dosolve G GG DD.

%%	   then cf_l (try pw).



expaper2 O1 O2 G GG DD :-
  O1 = (intgr  (X \ (2 + (3 * (expn X 2)))) F),
  G = (interact_solve O1 O2), 
  dosolve G GG DD.

%%	   then pl (maptac (orelse cf (then cf_l pw))).





