%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%	EXAMPLES:					  %%%
%%%	Sample mini-ML functions in Abstract Syntax	  %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

module mlexam.

%%% SOME LISTS: [1,2] and [3.4]
l12 (@ (@ cns (# 1)) (@ (@ cns (# 2)) nill)).
l34 (@ (@ cns (# 3)) (@ (@ cns (# 4)) nill)).


%%% FUNCTION DEFINITIONS %%%

%%% FACTORIAL FUNCTION %%%
fact1 (fix Fact\ (lamb N\ (cond (@ (@ == N) (# 0))
                                (# 1)
                               (@ (@ times N) 
				  (@ Fact (@ ( @ minus N) (# 1))))))).

%%% APPEND FUNCTION %%%
app1 (fix App\ (lamb K\ (lamb L\
                (cond (@ (@ == K) nill) 
                      L 
                      (@ (@ cns (@ hd K))  (@ (@ App (@ tl K)) L)))))).


%%% MUTUAL RECURSION EXAMPLE: EVEN/ODD FUNCTIONS %%%
evenodd1 (fix EO\ (&&
            (lamb X\ (cond (@ (@ == X) (# 0)) 
                           tt 
                           (@ (@ snd EO) (@ (@ minus X) (# 1)))))
            (lamb X\ (cond (@ (@ == X) (# 0))
                           ff
                           (@ (@ fst EO) (@ (@ minus X) (# 1))))))).


%%% SIMPLE GCD FUNCTION %%%
gcd1 (fix Gcd\ (lamb X\ (lamb Y\
		(cond (@ (@ == X) Y)
		      X
		      (cond (@ (@ lt X) Y)
			    (@ (@ Gcd  (@ (@ minus Y) X))  X)
			    (@ (@ Gcd  Y)  (@ (@ minus X) Y))))))).


%%% LENGTH FUNCTION %%%
len1 (fix Len\ (lamb L\
		(cond (@ (@ == L) nill)
		      (# 0)
		      (@ (@ plus (@ Len (@ tl L)))  (# 1))))).

%%% MAP FUNCTION %%%
map1 (fix Map\ (lamb F\ (lamb L\
		(cond (@ (@ == L) nill)
		      nill
		      (@ (@ cns  (@ F (@ hd L))) (@ (@ Map F) (@ tl L))))))).


%---------------------------------------------------------------------------%
