module meta_ex.

%%% Experimenting with equality.

type equ A -> A -> o.

equ X X.
d_equ (pi X \ (equ X X)).

equ1 (pi X \ (sigma Y \ (equ X Y))).
equ2 (sigma Y \ (pi X \ (equ X Y))).

% ?- d_equ DE, equ1 Yes, phyp DE eq => psolve Yes M.
% DE == pi X \ (equ X X)
% Yes == pi X \ (sigma Y \ (equ X Y))
% M == lam Q \ (pair Q (app eq Q)) 

%%% Experimenting with lists.

type append (list A) -> (list A) -> (list A) -> o.

append nil K K.
append (X :: L) K (X :: M) :- append L K M.

d_app (   pi K \ (append nil K K)
	, (pi L \ (pi K \ (pi M \ (pi X \
		 ( append L K M =>
		   append (X :: L) K (X :: M) )))))).
      
append1 L   (append (1 :: nil) (2 :: nil) L).
append2 L K (append L K (1 :: 2 :: 3 :: nil)).

%%% Experimenting with unary numbers.

kind  nat  type.

type z nat.
type s nat -> nat.
type pl nat -> nat -> nat.
type one nat.

type fib nat -> nat -> o.
type fiba nat -> nat -> o.

% fib accepts unary natural numbers as the first arguments and
% returns an answer in terms of plus and one.

fib z one.
fib (s z) one.
fib (s (s N)) (pl M1 M2) :- fiba N M2, fiba (s N) M1.

d_fib (    fib z one
        ,  fib (s z) one
        ,  (pi N\ (pi M1\ (pi M2\ 
	     ((fib N M2 , fib (s N) M1)
	       => fib (s (s N)) (pl M1 M2)))))
     ).

fiba z one.
fiba (s z) one.
fiba (s (s N)) (pl M1 M2) :- fiba N M2, (fiba N M2 => fiba (s N) M1).

d_fiba (     fiba z one
        ,  fiba (s z) one
        ,  (pi N\ (pi M1\ (pi M2\ 
	     (fiba N M2 => (fiba N M2 => fiba (s N) M1)
	       => fiba (s (s N)) (pl M1 M2)))))
     ).

fib1 M (fib (s (s (s z))) M).
fib2 M (fib (s (s (s (s (s z))))) M).

fib1a M (fiba (s (s (s z))) M).
fib2a M (fiba (s (s (s (s (s z))))) M).
