%%% Evaluation for the pure lambda calculus with zero, successor, and
%%% iteration.  This is done in a "call-by-value" way, which is OK, since
%%% we have strong normalization for the result of compiling programs in
%%% the second-order polymorphic lambda calculus.
%%% Author: fp.

module lameval.
import lamsig.

type do_red term -> term -> term -> o.
type eval   term -> term -> o.

do_red (lam M) N V :- !, eval (M N) V.
do_red (app (app *iternat* *zero*) C) H V :- !, eval C V.
do_red (app (app *iternat* (app *succ* M)) C) H V :- !,
   eval (app H (app (app (app *iternat* M) C) H)) V.

do_red M N (app M N).

eval (lam M) (lam M) :- !.

eval (app M N) V :- !,
  eval M M*,
  eval N N*,
  do_red M* N* V.

eval M M.
