%%% Module for EXPLICIT substitution predicates in the untyped
%%% lambda calculus.  Just for fun, actually.
%%% Author: fp, following ideas by Dale Miller.

module lamsubst.
import lamsig.

type	subst		(term -> term) -> term -> term -> o.
type	var		term -> o.

subst  (x \ (lam (z \ (N z x))))  M  (lam N*)  :-
    pi z \ (var z => subst (N z) M (N* z)).

subst  (x \ (app (N0 x) (N1 x))) M (app N0* N1*) :-
    subst N0 M N0*,
    subst N1 M N1*.
    
subst  (x \ *zero*) M *zero*.
subst  (x \ *succ*) M *succ*.
subst  (x \ *iternat*) M *iternat*.

subst  (x \ Y)  M  Y :- var Y.	% Imitations first!

subst  (x \ x)  M  M.		% Projections second!
