%%% Type inference for the second-order polymorphic Lambda calculus.
%%% Author: fp.

module polyinf.
import polysig.

type  tmtype	tm -> ta -> o.
index tmtype	1.

% It seems one would need the `var' predicate for a correct
% implementation of this check.
tmtype thisisahack Alpha :- !,
  error (write "Illegal free variable in input.").

tmtype (pmmlam     U) Alpha :- !,
  Alpha = (afun Beta Gamma),
  pi x\ (vartype x Beta => tmtype (U x) Gamma).

tmtype (mmlam Beta U) Alpha :- !,
  Alpha = (afun Beta Gamma),
  pi x\ (vartype x Beta => tmtype (U x) Gamma).

tmtype (mmapp U0 U1) Alpha :- !,
  tmtype U0 (afun Beta Alpha),
  tmtype U1 Beta.

tmtype (amlam U) Alpha :- !,
   Alpha = (del Beta),
   pi theta\ (tmtype (U theta) (Beta theta)).

tmtype (pmaapp U    ) Alpha :- !,
  tmtype U (del Beta),
  Alpha = (Beta Gamma).

tmtype (maapp U Gamma) Alpha :- !,
  tmtype U (del Beta),
  Alpha = (Beta Gamma).

tmtype (cm U Beta) Alpha :- !,
  tmtype U Beta,
  Alpha = Beta.

tmtype X Alpha :- vartype X Beta, !,
   Alpha = Beta.

tmtype X Alpha :- !,
    error (writesans "Unknown constant ", write X, nl).
