%%% A module with the signature for the second-order polymorphic Lambda
%%% calculus as represented in eLP.  We have the following conventions:
%%% a - prefix for "type".
%%% m - prefix for "terms".
%%% p - prefix for "partial".
%%% Author: fp

module polysig.

kind  ta        type.   % types.
kind  tm	type.   % terms.

type  afun      ta -> ta -> ta.		  % function type constructor.

type  mmlam     ta -> (tm -> tm) -> tm.	  % lambda.
type  pmmlam    (tm -> tm) -> tm.	  % type omitted.
type  mmapp     tm -> tm -> tm.		  % application.

type  del       (ta -> ta) -> ta.	  % universal type constructor.

type  amlam     (ta -> tm) -> tm.	  % type abstraction.
type  maapp	tm -> ta -> tm.		  % type application.
type  pmaapp	tm -> tm.		  % type omitted.

type  cm	tm -> ta -> tm.		  % explicit type.

% type  glet	tm -> (tm -> tm) -> tm.	  % term let.
% type  tlet	A -> (A -> tm) -> tm.	  % type let.

type  thisisahack  tm.  % For discovery of free term variables.
type  thisisatypehack ta. % For discovery of free term variables.

%%% Finally: recording of types in the context (such as after descending
%%% through a bound variable, or after making a "global" definition.

type  vartype	tm -> ta -> o.	% Remembering types of bound variables.
index vartype	1.		% An optimization for lookup of types.
