%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%	HFTRANS : Translation from higher-order to first-order terms %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

module hftrans.
import substaux.

kind	assoc		type.

type	ftrans		tm -> ftm -> o.
type	ftrans1		(list assoc) -> tm -> ftm -> o.
type	assoc		tm -> string -> assoc.
type    newname         list assoc -> string -> o.


ftrans M P :- ftrans1 nil M P.

ftrans1 Gamma (fv M) P :-
	newname Gamma X,
	pi C\(ftrans1 (cons (assoc C X) Gamma) (M C) P).

ftrans1 Gamma (abs M) (fabs X P) :-
	newname Gamma X,
	pi C\(ftrans1 (cons (assoc C X) Gamma) (M C) P).

ftrans1 Gamma (app M N)  (fapp P Q) :-
	ftrans1 Gamma M P,
	ftrans1 Gamma N Q.

ftrans1 Gamma C (fvar X) :-
	member (assoc C X) Gamma.


newname Gamma X :-
	member X (cons "x" (cons "y" (cons "z" (cons "u" (cons "v" 
		 (cons "w" (cons "s" (cons "t" nil)))))))),
	not (member (assoc C X) Gamma).