module sub3.

import substaux.

type	subst3	 	string -> ftm -> ftm -> ftm -> o.
type    getvar          string -> o.
type    notfree         string -> ftm -> o.

doc subst3 "Translation of subst2 to first-order syntax.".

subst3 X (fvar X) W W.					%%% .1

subst3 X Y W Y :- notfree X Y.				%%% .2

subst3 X (fapp S T) W (fapp U V) :-			%%% .
	subst3 X S W U,
	subst3 X T W V.

subst3 X (fabs Y S) W (fabs Z T) :- 			%%% .4
	not (X = Y),
	getvar Z,
	not (Z = X),
	notfree Z S,
	notfree Z W,
	subst3 Y S (fvar Z) U,
	subst3 X U W T.

getvar X :-
	member X (cons "x" (cons "y" (cons "z" (cons "u" (cons "v" 
		 (cons "w" (cons "s" (cons "t" nil)))))))).

notfree  X (fvar Y) :- not (X = Y).

notfree X (fapp M N) :-
	notfree X M,
	notfree X N.

notfree X (fabs Y S) :- X = Y.
notfree X (fabs Y S) :- not (X = Y),
	notfree X S.

