module sub4.

import substaux.

type	subst4	 	string -> ftm -> ftm -> ftm -> o.
type    getvar          string -> o.
type    notfree         string -> ftm -> o.

doc subst4 "Unfolds the definition of `notfree' in subst3.".

subst4 X (fvar X) W W.					%%% .1a

subst4 X (fvar Y) W (fvar Y) :- not (X = Y).		%%% .1b

subst4 X (fapp S T) W (fapp U V) :-			%%% .2
	subst4 X S W U,
	subst4 X T W V.

subst4 X (fabs Y S) W (fabs Y S) :- 			%%% .3a
	X = Y.

subst4 X (fabs Y S) W (fabs Y S) :- 			%%% .3b(i)
	not (X = Y),
	notfree X S.

subst4 X (fabs Y S) W (fabs Z T) :- 			%%% .3b(ii)
	not (X = Y),
	getvar Z,
	not (Z = X),
	notfree Z (fabs Y S),
	notfree Z W,
	subst4 Y S (fvar Z) U,
	subst4 X U W T.


getvar X :-
	member X (cons "x" (cons "y" (cons "z" (cons "u" (cons "v" 
		 (cons "w" (cons "s" (cons "t" nil)))))))).

notfree X (fvar Y) :- not (X = Y).

notfree X (fapp M N) :-
	notfree X M,
	notfree X N.

notfree X (fabs Y S) :- X = Y.
notfree X (fabs Y S) :- not (X = Y),
	notfree X S.

