module sub5.

import substaux.

type	subst5	 	string -> ftm -> ftm -> ftm -> o.
type    getvar          string -> o.
type    notfree         string -> ftm -> o.

doc subst5 "Another Unfolding of the definition of `notfree' in subst4.".


subst5 X (fvar X) W W.					%%% 3.1a

subst5 X (fvar Y) W (fvar Y) :- not (X = Y).		%%% 3.1b

subst5 X (fapp S T) W (fapp U V) :-			%%% 3.2
	subst5 X S W U,
	subst5 X T W V.

subst5 X (fabs Y S) W (fabs Y S) :- 			%%% 3.3a
	X = Y.

subst5 X (fabs Y S) W (fabs Y S) :- 			%%% 3.3b(i1)
	not (X = Y),
	notfree X S.

subst5 X (fabs Y S) W (fabs Y T) :- 			%%% 3.3b(i2)
	not (X = Y),
	notfree Y W,
	subst5 X S W T.

subst5 X (fabs Y S) W (fabs Z T) :- 			%%% 3.3b(ii)
	not (X = Y),
	getvar Z,
	not (Z = X),
	not (Z = Y),
	notfree Z S,
	notfree Z W,
	subst5 Y S (fvar Z) U,
	subst5 X U W T.


getvar X :-
	member X (cons "x" (cons "y" (cons "z" (cons "u" (cons "v" 
		 (cons "w" (cons "s" (cons "t" nil)))))))).

notfree X (fvar Y) :- not (X = Y).

notfree X (fapp M N) :-
	notfree X M,
	notfree X N.

notfree X (fabs Y S) :- X = Y.
notfree X (fabs Y S) :- not (X = Y),
	notfree X S.

