module substaux.

kind tm       type.	% higher-order abstract syntax
kind deb      type.	% de Bruijn notation
kind ftm      type.	% first-order syntax
kind dtm      type.	% director terms
kind dstr     type.	% director string elements

%%% higher-order signature
type abs      (tm -> tm) -> tm.
type app      tm -> tm -> tm.
type fv	      (tm -> tm) -> tm.

%%% deBruijn signature
type abs$     deb -> deb.
type app$     deb -> deb -> deb.
type deb      int -> deb.
type clo      (list deb) -> deb -> deb.

%%% first-order signature
type fabs     string -> ftm -> ftm.
type fapp     ftm -> ftm -> ftm.
type fvar     string -> ftm.

%%% director signature
type dapp     dtm -> dtm -> (list dstr) -> dtm.
type dvar     string -> (list dstr) -> dtm.
type `I       (list dstr) -> dtm.
type  b       dstr.
type  r       dstr.
type  l       dstr.
type  n       dstr.

type nth      int -> list A -> A -> o.
type member   A -> list A -> o.

nth 1 (cons X L) X.
nth N (cons X L) Y :- N1 is N - 1, nth N1 L Y.

member X (cons X L).
member X (cons Y L) :- member X L.