;;; -*- Mode: Lisp; Package: SLTERMG -*-
(in-package "SLTERM")  ;; creates package for abstract syntax. 

(in-package "SLTERMG")  ;; enters package for generated code.  

(use-package '("ERGOLISP" "OPER" "OCC" "TERM" "SORT" "SB-RUNTIME" "LANG" "NEWATTR"))


(export '())

(DEFPARAMETER *SLTERM-OPSIG-TABLE*
              (MAKE-OPSIG-TABLE
               '((#^SLTERM::MKEYTYPING .
                  #@("slterm"
                                                                      :=
                                                                      (#t(:SORT KEYWORD)
                                                                      #t(:SORT SLTERM:SLTYPE))
                                                                      :->
                                                                      #t(:SORT SLTERM::SMODENTRY)))
                (#^SLTERM::MODENTRIES .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:LIST (:SORT SLTERM::SMODENTRY)))
                                                                      :->
                                                                      #t(:SORT SLTERM::MODENTRIES)))
                (#^SLTERM::END-OF-INPUT .
                 #@("slterm"
                                                                      :=
                                                                      NIL
                                                                      :->
                                                                      #t(:SORT SLTERM::SLTERM-DOT)))
                (#^SLTERM:APPL .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM:SLTERM)
                                                                      #t(:SORT SLTERM:SLTERM))
                                                                      :->
                                                                      #t(:SORT
                                                              SLTERM:SLTERM)))
                (#^SLTERM:KFUN .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM:SLKIND))
                                                                      :->
                                                                      #t(:SORT SLTERM:SLKIND)))
                (#^SLTERM:CON .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM:SLCOBJ))
                                                                      :->
                                                                      #t(:SORT SLTERM:SLTERM)))
                (#^SLTERM:TFUN .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM:SLTYPE)
                                                                      #t(:SORT SLTERM:SLTYPE))
                                                                      :->
                                                                      #t(:SORT
                                                              SLTERM:SLTYPE)))
                (#^SLTERM:CNAMED .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SB-RUNTIME::ID))
                                                                      :->
                                                                      #t(:SORT SLTERM:SLCOBJ)))
                (#^SLTERM:TAPPL .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM:SLTYPE)
                                                                      #t(:SORT SLTERM:SLTYPE))
                                                                      :->
                                                                      #t(:SORT
                                                              SLTERM:SLTYPE)))
                (#^SLTERM::MINDEXING .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SB-RUNTIME::ID)
                                                                      #t(:SORT NUMBER))
                                                                      :->
                                                                      #t(:SORT SLTERM::SMODENTRY)))
                (#^SLTERM::MKINDING .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SB-RUNTIME::ID)
                                                                      #t(:SORT SLTERM:SLKIND))
                                                                      :->
                                                                      #t(:SORT
                                                               SLTERM::SMODENTRY)))
                (#^SLTERM::CKEYWORD .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT KEYWORD))
                                                                      :->
                                                                      #t(:SORT SLTERM:SLCOBJ)))
                (#^SLTERM::ISID .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SB-RUNTIME::ID))
                                                                      :->
                                                                      #t(:SORT SLTERM::STRING-OR-ID)))
                (#^SLTERM:CSTRING .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT STRING))
                                                                      :->
                                                                      #t(:SORT SLTERM:SLCOBJ)))
                (#^SLTERM::ISSTRING .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT STRING))
                                                                      :->
                                                                      #t(:SORT SLTERM::STRING-OR-ID)))
                (#^SLTERM::MSDFORM .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM:SLTERM))
                                                                      :->
                                                                      #t(:SORT SLTERM::SMODENTRY)))
                (#^SLTERM:KTYPE .
                 #@("slterm"
                                                                      :=
                                                                      NIL
                                                                      :->
                                                                      #t(:SORT SLTERM:SLKIND)))
                (#^SLTERM::IMPORT-LIST .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:LIST (:SORT SLTERM::STRING-OR-ID)))
                                                                      :->
                                                                      #t(:SORT SLTERM::IMPORT-LIST)))
                (#^SLTERM::MKEYINDEXING .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT KEYWORD)
                                                                      #t(:SORT NUMBER))
                                                                      :->
                                                                      #t(:SORT SLTERM::SMODENTRY)))
                (#^SLTERM:TCON .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SB-RUNTIME::ID))
                                                                      :->
                                                                      #t(:SORT SLTERM:SLTYPE)))
                (#^SLTERM:TYPED .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM:SLTERM)
                                                                      #t(:SORT SLTERM:SLTYPE))
                                                                      :->
                                                                      #t(:SORT
                                                              SLTERM:SLTERM)))
                (#^SLTERM::MTYPING .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SB-RUNTIME::ID)
                                                                      #t(:SORT SLTERM:SLTYPE))
                                                                      :->
                                                                      #t(:SORT
                                                               SLTERM::SMODENTRY)))
                (#^SLTERM:ABST .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM:SLTERM)
                                                                      #t(:SORT SLTERM:SLTERM))
                                                                      :->
                                                                      #t(:SORT
                                                              SLTERM:SLTERM)))
                (#^SLTERM:CNUMBER .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT NUMBER))
                                                                      :->
                                                                      #t(:SORT SLTERM:SLCOBJ)))
                (#^SLTERM::SIMPORT .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM::IMPORT-LIST))
                                                                      :->
                                                                      #t(:SORT SLTERM::SIMPORT)))
                (#^SLTERM::SLTERM-DOT .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM:SLTERM))
                                                                      :->
                                                                      #t(:SORT SLTERM::SLTERM-DOT)))
                (#^SLTERM::SMODULE .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:SORT SLTERM::STRING-OR-ID)
                                                                      #t(:SORT SLTERM::IMPORTS)
                                                                      #t(:SORT
                                                                    SLTERM::MODENTRIES))
                                                                      :->
                                                                      #t(:SORT
                                                                      SLTERM::SMODULE)))
                (#^SLTERM:ELLIDEDSLTYPE .
                 #@("slterm"
                                                                      :=
                                                                      NIL
                                                                      :->
                                                                      #t(:SORT SLTERM:SLTYPE)))
                (#^SLTERM::IMPORTS .
                 #@("slterm"
                                                                      :=
                                                                      (#t(:LIST (:SORT SLTERM::SIMPORT)))
                                                                      :->
                                                                      #t(:SORT SLTERM::IMPORTS)))
                (#^SLTERM:ELLIDEDSLTERM .
                 #@("slterm"
                                                                      :=
                                                                      NIL
                                                                      :->
                                                                      #t(:SORT SLTERM:SLTERM)))))) 


(DEFPARAMETER *SLTERM-SORT-TABLE*
              (MAKE-SORT-TABLE
               '((#t(:SORT SLTERM::SIMPORT) .
                  #t(:OP
                                                                      #^SLTERM::SIMPORT))
                (#t(:SORT
                                                                      SLTERM:SLCOBJ)
                 .
                 #t(:UNION
                                                                      (:OP
                                                                      #^SLTERM:CSTRING)
                                                                      (:OP
                                                                      #^SLTERM:CNUMBER)
                                                                      (:OP
                                                                      #^SLTERM:CNAMED)
                                                                      (:OP
                                                                      #^SLTERM::CKEYWORD)))
                (#t(:SORT
                                                                      SLTERM::SLTERM-DOT)
                 .
                 #t(:UNION
                                                                      (:OP
                                                                      #^SLTERM::END-OF-INPUT)
                                                                      (:OP
                                                                      #^SLTERM::SLTERM-DOT)))
                (#t(:SORT
                                                                      SLTERM::IMPORT-LIST)
                 .
                 #t(:OP
                                                                      #^SLTERM::IMPORT-LIST))
                (#t(:SORT
                                                                      SLTERM:CON)
                 .
                 #t(:OP
                                                                      #^SLTERM:CON))
                (#t(:SORT
                                                                      SLTERM::STRING-OR-ID)
                 .
                 #t(:UNION
                                                                      (:OP
                                                                      #^SLTERM::ISID)
                                                                      (:OP
                                                                      #^SLTERM::ISSTRING)))
                (#t(:SORT
                                                                      SLTERM::SMODULE)
                 .
                 #t(:OP
                                                                      #^SLTERM::SMODULE))
                (#t(:SORT
                                                                      SLTERM::SMODENTRY)
                 .
                 #t(:UNION
                                                                      (:OP
                                                                      #^SLTERM::MSDFORM)
                                                                      (:OP
                                                                      #^SLTERM::MKEYINDEXING)
                                                                      (:OP
                                                                      #^SLTERM::MINDEXING)
                                                                      (:OP
                                                                      #^SLTERM::MKEYTYPING)
                                                                      (:OP
                                                                      #^SLTERM::MTYPING)
                                                                      (:OP
                                                                      #^SLTERM::MKINDING)))
                (#t(:SORT
                                                                      SLTERM:SLTYPE)
                 .
                 #t(:UNION
                                                                      (:OP
                                                                      #^SLTERM:ELLIDEDSLTYPE)
                                                                      (:OP
                                                                      #^SLTERM:TAPPL)
                                                                      (:OP
                                                                      #^SLTERM:TFUN)
                                                                      (:OP
                                                                      #^SLTERM:TCON)))
                (#t(:SORT
                                                                      SLTERM:APPL)
                 .
                 #t(:OP
                                                                      #^SLTERM:APPL))
                (#t(:SORT
                                                                      SLTERM::CKEYWORD)
                 .
                 #t(:OP
                                                                      #^SLTERM::CKEYWORD))
                (#t(:SORT
                                                                      SLTERM:SLTERM)
                 .
                 #t(:UNION
                                                                      (:OP
                                                                      #^SLTERM:TYPED)
                                                                      (:OP
                                                                      #^SLTERM:ABST)
                                                                      (:OP
                                                                      #^SLTERM:APPL)
                                                                      (:OP
                                                                      #^SLTERM:CON)
                                                                      (:OP
                                                                      #^SLTERM:ELLIDEDSLTERM)))
                (#t(:SORT
                                                                      SLTERM::MODENTRIES)
                 .
                 #t(:OP
                                                                      #^SLTERM::MODENTRIES))
                (#t(:SORT
                                                                      SLTERM:SLKIND)
                 .
                 #t(:UNION
                                                                      (:OP
                                                                      #^SLTERM:KFUN)
                                                                      (:OP
                                                                      #^SLTERM:KTYPE)))
                (#t(:SORT
                                                                      SLTERM::IMPORTS)
                 .
                 #t(:OP
                                                                      #^SLTERM::IMPORTS))))) 

(lang:lang-define 
:name "slterm"
:conc-name "slterm"
:code-package "SLTERMG"
:abs-syn-package "SLTERM"
:use-packages '("ERGOLISP" "OPER" "OCC" "TERM" "SORT" "SB-RUNTIME" "LANG" "NEWATTR")
:sub-languages '("LEXICAL-TERMINALS")
:unparse-nts 'T
:parse-routine-name 'SLTERMG::SLTERM-PARSE
:unparse-routine-name 'SLTERMG::SLTERM-UNPARSE
:win-unparse-routine-name 'SLTERMG::SLTERM-WIN-UNPARSE
:sort-table-name 'SLTERMG::*SLTERM-SORT-TABLE*
:opsig-table-name 'SLTERMG::*SLTERM-OPSIG-TABLE*
)

