;;; -*- Mode: Lisp; Package: LTERM -*-
;;;
;;; The system dependent stuff from slterm-io.  Depends on the box facility.
;;;
;;; Author: Conal Elliott.  Last Modified Mon Sep 11 06:09:29 1989
;;;
;;; Sccs Id @(#)slterm-system.lisp	1.7 9/15/89
;;; ******************************************************************* ;;;
;;;         (c) Copyright 1989 by Carnegie Mellon University.           ;;;
;;;                        All rights reserved.                         ;;;
;;;         This code was written as part of the Ergo project.          ;;;
;;;  If you want to use this code or any Ergo software, please contact  ;;;
;;;			Frank Pfenning (fp@cs.cmu.edu)			;;;
;;; ******************************************************************* ;;;


(in-package :LTERM)

(export '(load-slterm-lang))

;;;; Functions for loading and generating parsers, etc.

(defun load-slterm-lang (directory)
  "Generate SB support for slterms using the grammar `slterm-gr.txt'in the given
DIRECTORY.  If optional second argument is true, only load if necessary."
  ;; Temporarily make the box-path of the slterm-lang box be the given
  ;; directory, while re-boxgen'ing.
  ;; Unwind-protect so that we reset the box-path even if error out.
  (let ( #+allegro (excl:*redefinition-warnings* nil)
         #+lucid (lcl:*redefinition-action* nil)
	 (path-was (tools:box-path (tools::get-existent-box "slterm-lang"))))
    (when (not (eq directory :standard))
      (setf (tools:box-path (tools::get-existent-box "slterm-lang"))
	    (list directory)))
    (unwind-protect
	(let ((tools:*system-administration-mode* t))
	  (tools:boxgen "slterm-lang"))
      (when (not (eq directory :standard))
	(setf (tools:box-path (tools::get-existent-box "slterm-lang"))
	      path-was)))))
