;;; -*- Mode: Lisp; Package: SLTERM -*-
;;;
;;; The syntactic representation of terms and types.
;;;
;;; Author: Conal Elliott.  Last Modified Mon Sep 11 06:09:32 1989
;;;
;;; Sccs Id @(#)slterm.lisp	1.17 9/15/89
;;; ******************************************************************* ;;;
;;;         (c) Copyright 1989 by Carnegie Mellon University.           ;;;
;;;                        All rights reserved.                         ;;;
;;;         This code was written as part of the Ergo project.          ;;;
;;;  If you want to use this code or any Ergo software, please contact  ;;;
;;;			Frank Pfenning (fp@cs.cmu.edu)			;;;
;;; ******************************************************************* ;;;


(in-package :SLTERM) (use-package :ergolisp)

(defsconstr "

    datatype Slterm  =		% Syntactic form of lterms
	 Con of Slcobj
      |  Var of Symbol
      |  Appl of Slterm, Slterm
      |  Abst of Vbind, Slterm
      |  Typed of Slterm, Sltype
      |  EllidedSlterm
      |	 Escape of T		% Used for lterm-to-slterm translation.

    datatype Vbind  =		% Variable binding with optional type.
	 Vuntyped of Symbol
      |  Vtyped of Symbol, Sltype

    datatype Slcobj  =		% Syntactic form of lterm constants objects.
	 Cstring of String
      |  Cnumber of Number
      |  Cnamed of Symbol

    datatype Sltype  =		% Syntactic form of ltypes
	 Tcon of Symbol
      |  Tvar of Symbol
      |  Tfun of Sltype, Sltype
      |  Tappl of Sltype, Sltype
      |  EllidedSltype

    datatype Slkind  =		% Syntactic form of ltype kinds
	 Ktype
      |  Kfun of Slkind

")
